%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Name:           python-jcc
Version:        1.9
Release:        4%{?dist}
Summary:        C++ code generator for calling Java from C++/Python

Group:          Development/Languages
License:        MIT
URL:            http://pypi.python.org/pypi/JCC/
Source0:        http://pypi.python.org/packages/source/J/JCC/JCC-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       java-1.6.0-openjdk
BuildRequires:  python-devel java-1.6.0-openjdk-devel
# Theoretically python-setuptools is only required on Python 2.3 but
# if this is missing, all JCC files are put into /site-packages which is what
# we like to get.
BuildRequires:  python-setuptools

%description
JCC is a C++ code generator for producing the glue code necessary to call
into Java classes from CPython via Java's Native Invocation Interface (JNI).

JCC generates C++ wrapper classes that hide all the gory details of JNI
access as well Java memory and object reference management.

JCC generates CPython types that make these C++ classes accessible from a
Python interpreter. JCC attempts to make these Python types pythonic by
detecting iterators and property accessors. Iterators and mappings may also
be declared to JCC.

%package devel
Summary: Source code for JCC wrapper classes
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the source code which is needed by JCC to generate 
wrapper classes.

%prep
%setup -q -n JCC-%{version}

%build

JVM_BASEPATH="/usr/lib/jvm"

# even on x86_64 the jvm is located below /usr/lib
OPENJDK_JRE_BASEPATH="${JVM_BASEPATH}/jre-openjdk"
OPENJDK_INCLUDE="${JVM_BASEPATH}/java-openjdk/include"

LIBDIR_NAME=`echo %{_libdir} | sed -e "s/^.*\/\(lib6\?4\?\).*$/\1/"`
echo "$LIBDIR_NAME"
if [ "$LIBDIR_NAME" == "lib" ]; then
        OPENJDK_LIBDIR=${OPENJDK_JRE_BASEPATH}/lib/i386;
        OPENJDK_VMDIR=${OPENJDK_LIBDIR}/client
else
        OPENJDK_LIBDIR=${OPENJDK_JRE_BASEPATH}/lib/amd64;
        OPENJDK_VMDIR=${OPENJDK_LIBDIR}/server
fi


INCLUDE="${OPENJDK_INCLUDE}::${OPENJDK_INCLUDE}/linux"
LFLAGS="-L${OPENJDK_LIBDIR}::-ljava::-Wl,-rpath=${OPENJDK_LIBDIR}:${OPENJDK_VMDIR}"
#LFLAGS="-L${OPENJDK_LIBDIR}:-ljava:-Wl"
CFLAGS="$RPM_OPT_FLAGS"
NUM_FILES=2

JCC_ARGSEP="::" JCC_INCLUDES=${INCLUDE} JCC_LFLAGS=${LFLAGS} CFLAGS="${CFLAGS}"\
    NUM_FILES=${NUM_FILES} \
        %{__python} setup.py build

%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
 
%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE README
%dir %{python_sitearch}/jcc
%{python_sitearch}/jcc/*.py
%{python_sitearch}/jcc/*.pyc
%{python_sitearch}/jcc/*.pyo
%attr(0644,root,root) %{python_sitearch}/jcc/_jcc.so
%{python_sitearch}/JCC*
%attr(0644,root,root) %{python_sitearch}/libjcc.so

%files devel
%{python_sitearch}/jcc/sources


%changelog
* Mon Jun 02 2008 Felix Schwarz <felix.schwarz@oss.schwarz.eu> - 1.9-4
- fixed permissions
- moved header files to devel package

* Tue May 27 2008 Felix Schwarz <felix.schwarz@oss.schwarz.eu> - 1.9-3
- renamed package to python-jcc
- removed patch for setup (we can use environment variables)
- added some scripting logic so that the package builds on i386 and x86_64

* Thu May 22 2008 Felix Schwarz <felix.schwarz@oss.schwarz.eu> - 1.9-2
- re-added sources directory as it is needed for compiling PyLucene (-> -devel?)

* Thu May 22 2008 Felix Schwarz <felix.schwarz@oss.schwarz.eu> - 1.9-1
- initial packaging

